#define _GNU_SOURCE
#include<stdio.h>
#include<stdlib.h>
#include<math.h>

/* Description:
Generate all text for large PI numbers

adjust:
 - string length
 - font
 - yposition

*/

	double ColPosition,RowPosition;


int main()
{

	int nCurrentRow;
	int nCurrentCharInRow;
	int nCurrentCharInString=0;
	int nLastCharInString;
	float fFontSize;	//font size which changes for each row.

	//settings
	int nLastRow = 12;	//Number of rows to print.
	int nLength = 7;	//Initial length of pi characters for first row.
	float fYPosition=24.0;	//Initial height of first row from bottom of the poster
	float fLengthRatio = 1.3;	//Ratio of changing row-length, font-size, Y-Position from top to bottom of poster


	FILE *fp;
	char * line = NULL;
	size_t len = 0;
	ssize_t read;

	//Read in one line of the extra long pi string for processing later.
	//code snippet from: man getline
	fp = fopen("foldedpi.txt","r");
	if (fp == NULL)
		exit(EXIT_FAILURE);
	read = getline(&line, &len, fp);
	//printf("Retrieved line of length %zu :\n", read);
	//printf("%s", line);
	fclose(fp);



	for ( nCurrentRow= 1; nCurrentRow<=nLastRow ; nCurrentRow += 1){

	//Calculate font size to fit characters into width of row.
	//fFontSize = 2800.0 / nLength - (nLength*.01);
	fFontSize = 2800.0 / nLength;

	printf("\\rput[t]{0}(10.25,%.2f in){\\textcolor{darkgreen}{\\changefont{%.3f pt}",fYPosition,fFontSize);

	nLastCharInString = 10;

	for ( nCurrentCharInRow= 1; nCurrentCharInRow<=nLength ; nCurrentCharInRow += 1){

		printf("%c",line[nCurrentCharInString]);
		nCurrentCharInString += 1;
	}

	//Print remaining characters of line.
	printf("}}\n");

	//Determine new length of string for next iteration
	nLength = nLength*fLengthRatio;

	//Determine new Y-Position for next line
	fYPosition = fYPosition - fFontSize/74.0;

	}

	if (line)
		free(line);
	return EXIT_SUCCESS;


}
